## galaxy-开发/测试环境 docker-compose
## services
1. php7
2. nginx
3. java-notice
4. java-biz-platform
5. java-flowengine
6. java-intelligentwriting
7. java-client

### hostfile服务地址处理
- vendor/galaxy/handle/src/HostFile/test.php
```php
<?php

return [
    'BaseMicros'       => ['host' => '192.168.11.175', 'port' => '9301'],
    'MarketMicros'     => ['host' => '192.168.11.175', 'port' => '9302'],
    'FlowMicros'       => ['host' => '192.168.11.175', 'port' => '9303'],
    'UserMicros'       => ['host' => '192.168.11.175', 'port' => '9304'],
    'FlowEngineMicros' => ['host' => '192.168.11.175', 'port' => '9305'],
    'ServerSiteMicros' => ['host' => '192.168.11.175', 'port' => '9310'],
    'NoticeMicros'     => ['host' => '192.168.11.175', 'port' => '9307'],
    'PromotionMicros'  => ['host' => '192.168.11.175', 'port' => '9312'],
    'MemberMicros'     => ['host' => '192.168.11.175', 'port' => '9313'],
    'PresaleMicros'    => ['host' => '192.168.11.175', 'port' => '9316'],
    'BizPlatform'      => ['host' => 'http://test.bizplatform.galaxy-immi.com', 'port' => '80'],
    'CrmClient'        => ['host' => 'http://test.crm-client.galaxy-immi.com', 'port' => '80'],
    'common-server'    => ['host' => 'test.common-server.galaxy-immi.com', 'port' => '9321'],
    'workflow-server'  => ['host' => 'http://test.workflow-server.galaxy-immi.com', 'port' => '9324'],
    # 数据仓库
    'data-center'      => ['host' => 'https://dw-admin.galaxy-immi.com', 'port' => '443'],
    'node'             => ['host' => 'http://172.18.18.3', 'port' => '3007'],
];

```

### 服务目录汇总

| 服务名                   | 描述                          | 仓库地址                                                                          | 目录名称                          | 状态    | 技术栈 | 端口                                  | 备注                 |
|:------------------------|:-----------------------------|:---------------------------------------------------------------------------------|:--------------------------------|:-------|:------|:-------------------------------------|:--------------------|
| BaseMicros              | 无                           | -                                                                                | -                               | 疑似弃用 | -     | -                                    |                     |
| MarketMicros            | 无                           | -                                                                                | -                               | 疑似弃用 | -     | -                                    |                     |
| FlowMicros              | Crm重构-流程管理相关的微服务      | http://gitlab.galaxy-immi.com/colnet/bp/FlowMicros.git                           | flowmicros                      | 正常    | php   | $GALAXY_FLOW_MICROS_API_HTTP_PORT    |                     |
| UserMicros              | Crm重构-用户管理相关的微服务      | http://gitlab.galaxy-immi.com/colnet/bp/UserMicros.git                           | user-micros                     | 正常    | php   | $GALAXY_USER_MICROS_API_HTTP_PORT    |                     |
| FlowEngineMicros        | 工作流引擎                     | http://gitlab.galaxy-immi.com/colnet/engine.git                                  | flowengine                      | 正常    | java  | 80 (单独容器服务,内部端口)               |                     |
| ServerSiteMicros        | 服务端相关的微服务              | http://gitlab.galaxy-immi.com/colnet/mp/ServerSiteMirocs.git                     | server-site                     | 正常     | php  | $GALAXY_SERVER_SITE_API_HTTP_PORT    |                     |
| NoticeMicros            | 通用通知服务                   | http://gitlab.galaxy-immi.com/colnet/notice.git                                  | notice                          | 正常    | java  | 80                                   |                     |
| PromotionMicros         | 无                           | -                                                                                | -                               | 疑似弃用 | -     | -                                    |                     |
| MemberMicros            | MemberMicros                 | http://gitlab.galaxy-immi.com/colnet/bp/MemberMicros.git                         | member-micros                   | 正常    | php   | $GALAXY_MEMBER_API_HTTP_PORT         |                     |
| PresaleMicros           | PresaleMicros                | http://gitlab.galaxy-immi.com/colnet/fp/PresaleMicros.git                        | presale-micros                  | 正常    | php   | $GALAXY_PRESALE_MICROS_API_HTTP_PORT |                     |
| BizPlatform             | BizPlatform                  | http://gitlab.galaxy-immi.com/colnet/biz-platform.git                            | biz-platform                    | 正常    | java  | 80                                   |                     |
| CrmClient               | 客户端微服务                   | http://gitlab.galaxy-immi.com/colnet/bp/ClientMicros.git                         | client                          | 正常    | java  | java:80                              | hostfile配置前端地址   |
| CrmClient               | crm文案部客户端前端             | http://gitlab.galaxy-immi.com/Front-end-group/CrmClientHtml.git                  | crm-client                      | 正常    | vue   | vue:$OLD_CRM_CLIENT_HTTP_PORT        | hostfile配置前端地址  |
| common-server           | 银河公共服务                   | http://gitlab.galaxy-immi.com/colnet/common-server.git                           | common-server                   | 正常    | php   | $GALAXY_COMMON_SERVER_API_HTTP_PORT  |                     |
| workflow-server         | 工作流引擎                     | http://gitlab.galaxy-immi.com/colnet/bp/galaxy-workflow.git                      | galaxy-workflow                 | 正常    | php   | $GALAXY_WORKFLOW_API_HTTP_PORT       |                     |
| data-center             | -                            | -                                                                                | -                               | 正常    | -     | -                                    | 待后续补充            |
| node                    | -                            | -                                                                                | -                               | 正常    | -     | -                                    | 待后续补充            |
| CRM                     | 新CRM系统服务端                | http://gitlab.galaxy-immi.com/colnet/fp/CRM.git                                  | crm                             | 正常    | vue   | $OLD_CRM_HTTP_PORT                   |                     |
| CRM-ADMIN               | 新CRM系统管理端                | http://gitlab.galaxy-immi.com/colnet/fp/CRM-Admin.git                            | crm-admin                       | 正常    | vue   | $OLD_CRM_ADMIN_HTTP_PORT             |                     |
| DWP/MAIN                | 文案系统                      | http://gitlab.galaxy-immi.com/Front-end-group/Service-Front/Document-System.git  | dwp/main                        | 正常     | vue  | $DWP_HTTP_PORT                       |                     |
| DWP/SUBAPP/Chatbot      | Chatbot智能机器人配置端         | http://gitlab.galaxy-immi.com/Front-end-group/Manage-Frame/Chatbot.git           | dwp/subapp/chatbot_admin        | 正常    | vue   | $DWP_HTTP_PORT                       |                     |
| DWP/SUBAPP/earlyWarning | 智能预警/代办                  | http://gitlab.galaxy-immi.com/Front-end-group/Manage-Frame/Early-Warning.git     | dwp/sub/app/earlyWarning        | 正常    | vue   | $DWP_HTTP_PORT                       |                     |
| DWP/SUBAPP/userInfo     | dwp项目管理-客户详情            | http://gitlab.galaxy-immi.com/Front-end-group/Service-Front/User-Information.git | dwp/sub/app/userInfo            | 正常    | vue   | $DWP_HTTP_PORT                       |                     |
| Entry                   | 香港入境处身份证预约抢号          | http://gitlab.galaxy-immi.com/colnet/mp/Entry.git                                | entry                           | 正常    | vue   | $GALAXY_ENTRY_API_HTTP_PORT          |                     |
| galaxy-crm              | -                            | http://gitlab.galaxy-immi.com/micro/galaxy-crm.git                               | galaxy-crm                      | 正常    | php   | $GALAXY_CRM_API_HTTP_PORT            |                     |
| intelligentwriting      | 智能写作后台                   | http://gitlab.galaxy-immi.com/colnet/smart-writing/Intelligentwriting.git        | intelligentwriting              | 正常    | java  | $OLD_CRM_ADMIN_HTTP_PORT             | old crm代理到java服务 |
| MicroserviceGateway     | micros-gateway               | http://gitlab.galaxy-immi.com/colnet/gateway/MicroserviceGateway.git             | micros-gateway                  | 正常    | php   | $GALAXY_MICROS_GATEWAY_API_HTTP_PORT | 代理转发             |
| user-information-system | 用户基础信息平台（981/997)      | http://gitlab.galaxy-immi.com/colnet/fp/User-Information-System.git              | user-information-system         | 正常     | vue  | $OLD_CRM_USER_HTTP_PORT              |                     |
| Notice-Center           | Notice-Center                | http://gitlab.galaxy-immi.com/colnet/noticeCenter.git                            | notice-center                   | 正常    | php   | $NOTICE_CENTER_HTTP_PORT             |                     |
| Notice-FRONT            | Notice-Center前端-智能预警/代办 | http://gitlab.galaxy-immi.com/Front-end-group/Manage-Frame/Early-Warning.git     | smartwhale/subapp/early_warning | 正常    | vue   | $VUE_NOTICE_CENTER_HTTP_PORT         |                     |
| domain-module           | 领域服务                      | http://gitlab.galaxy-immi.com/colnet/domain-module.git                           | domain-module                   | 待定     | php  | -                                    | php8                |

todo : test-doc.galaxy-immi.com 智能写作


### php7.4扩展
| 名称             |
|:----------------|
| bcmath          |
| Core            |
| ctype           |
| curl            |
| date            |
| dom             |
| fileinfo        |
| filter          |
| gd              |
| hash            |
| iconv           |
| imagick         |
| imap            |
| intl            |
| json            |
| libxml          |
| mbstring        |
| mongodb         |
| mysqli          |
| mysqlnd         |
| openssl         |
| pcntl           |
| pcre            |
| PDO             |
| pdo_mysql       |
| pdo_pgsql       |
| Phar            |
| posix           |
| protobuf        |
| rdkafka         |
| readline        |
| redis           |
| Reflection      |
| session         |
| SimpleXML       |
| sockets         |
| SPL             |
| standard        |
| swoole          |
| sysvmsg         |
| sysvsem         |
| sysvshm         |
| tideways_xhprof |
| tidy            |
| tokenizer       |
| xlswriter       |
| xml             |
| xmlreader       |
| xmlrpc          |
| xmlwriter       |
| xsl             |
| Zend OPcache    |
| zip             |
| zlib            |


## 配置文件处理
如何让服务内部调度

## 安装与部署
1. 本地或远程机器 git clone 仓库代码
```shell script
git clone git@gitlab.galaxy-immi.com:kunkka.wh/docker-test.git
cd galaxy
cp .env.example .env 
# 修改.env
# ENV = 环境
# PORT = 服务端口
# CODE_DIR = 挂载目录
# 部署代码
# 启动容器环境 docker-compose/docker compose
docker compose up -d # 或 docker-compose up -d
# 销毁环境环境
docker compose down --rmi all # 销毁并删除镜像
```
2. portainer使用(推荐)
   - compose-yaml文件变更时，自动更新容器环境
     - webhook
     - 定时任务


## 代码更新


## 执行脚本

## 执行计划任务

## 常驻进程管理


## 备注
